# This file is released under GPL license
# Copyright (C) 2003 by Roberto Natella
# roberto.natella@virgilio.it

import string
import xml.dom.minidom
import urllib
import tempfile
import os
import os.path
import time
import re

iconpath = '/usr/share/apps/BPLmenu/'

delay = 60 * 10     # seconds to wait to refresh rdf news

urls = ["http://blackpanther.hu/backend.php","http://www.freshmeat.net/backend/fm.rdf","http://www.kde.org/dotkdeorg.rdf"];

logos = {}
items = {}

logos['http://blackpanther.hu/backend.php']={}
logos['http://blackpanther.hu/backend.php']['link'] = iconpath+'slashdot.gif'
logos['http://blackpanther.hu/backend.php']['dims'] = [ 150, 40 ]
logos['http://www.freshmeat.net/backend/fm.rdf']={}
logos['http://www.freshmeat.net/backend/fm.rdf']['link'] = iconpath+'freshmeat.png';
logos['http://www.freshmeat.net/backend/fm.rdf']['dims'] = [ 40, 40 ]
logos['http://www.kde.org/dotkdeorg.rdf']={}
logos['http://www.kde.org/dotkdeorg.rdf']['link'] = iconpath+'kdedotnews.png';
logos['http://www.kde.org/dotkdeorg.rdf']['dims'] = [ 150, 40 ]

def BPLmenu_main(dir, lastmodif, lastread):

    tmpdir = tempfile.gettempdir()

    for url in urls:

        name = re.search(r"\b\w*?.rdf\b$",url).group()
        file = tmpdir+"/"+name

        if( os.path.exists(file) and (time.time()-os.path.getmtime(file))<delay ):
            #tmpfile = open(file,"r")
            #text = tmpfile.read()
            return ''
        else:
            rdffile = urllib.urlopen(url)
            text = rdffile.read()
            tmpfile = open(file,"w")
            tmpfile.write(text)
            tmpfile.close
    
        dom = xml.dom.minidom.parseString( text )
    
        channel = dom.getElementsByTagName("channel")[0]    
    
        title = channel.getElementsByTagName("title")[0]
        title = getText(title.childNodes)
    
        news = dom.getElementsByTagName("item")

        items[url] = []
    
        for n in news:
            itemtitle = n.getElementsByTagName("title")[0]
            itemtitle = getText(itemtitle.childNodes)
    
            itemlink = n.getElementsByTagName("link")[0]
            itemlink = getText(itemlink.childNodes)
    
            items[url].append({'link' : itemlink, 'title' : itemtitle});

    html = '''

    <html>
    <head>
    <title>News Feeder</title>

    <link rel="stylesheet" href="keramik.css">

    <script language="JavaScript1.2">
    /***** Based on Thomas Brattli fadescript *****/

    // The delay between the slide and the fade (in milliseconds),
    // bigger value=more time
    delayslidefade=5000;

    // The delay between the fade and the next slide
    delayfadeslide=1000;

    //Slide speed (how many pixels per time)
    movePx=10;

    // Do you wan't it to start over on the first one when it's gone trought all the news?
    // (set to 0 if not)
    var loop=1;

    // What font do you wan't it use?
    fontface='arial,helvetiva';

    // What font-size (in pixel)?
    fontsize=10;

    // Do you wan't it to fade out? 1 for on, 0 for off
    fadeback=1;

    // Set the colors, first color is same as background, last color is the color
    // it stops at:
    // You can have up to 7 colors, set the ones you wan't use to 0
    colors=new Array();
    colors[0]='#FFFFFF';
    colors[1]='#EEEEEE';
    colors[2]='#CCCCCC';
    colors[3]='#999999';
    colors[4]='#666666';
    colors[5]='#333333';
    colors[6]='#000000';

    news=new Array();

    '''

    i = 0
    maxlenght = 50

    p = re.compile('(")')

    for url in items:
        html += "\nnews["+i.__str__()+"]=new Array();\n\n"
        n = 0
        for item in items[url]:
            if item['title'].__len__() > maxlenght:
                item['title'] = item['title'][:maxlenght-3] + '...'
            item['title'] = p.sub('\'',item['title'])

            html += "news["+i.__str__()+"]["+n.__str__()+"]=new Array();\n"
            html += 'news['+i.__str__()+']['+n.__str__()+']["text"]="'+item['title']+'";'+"\n";
            html += 'news['+i.__str__()+']['+n.__str__()+']["link"]="'+item['link']+'";'+"\n";
            n = n + 1
        i = i + 1

    html += '''

    /***** Dont change anything below this! *****/

    var shift=150;

    var divnr = 0;

    oNews = new Array();

    function makeObj(obj,nest)
    {
        nest = (!nest) ? '' :' document.'+nest+'.';
        item = new Object();
        item.css = eval(obj+'.style');
        item.writeref = eval(obj);
        item.fadeIt = b_fadeIt;
        item.left = b_getleft;
        item.top = b_gettop;
        item.obj = obj + "Object";
        eval(item.obj + "=item");
        return item;
    }

    function b_getleft()
    {
        var gleft=eval(this.css.pixelLeft);
        return gleft;
    }

    function b_gettop()
    {
        var gleft=eval(this.css.pixelTop);
        return gleft;
    }

    function b_fadeIt(id,text,link,font,size,speed,fn,num,c0,c1,c2,c3,c4,c5,c6)
    {
	if(num<arguments.length && arguments[num]!=0)
        {
	    writetext='<a href="'+link+'" style="text-decoration:none; font-size:'+size+'px">'
		        +'<font face="'+font+'" color="'+arguments[num]+'">'+text+'</font></a>';
	    oNews[id].writeref.innerHTML=writetext;
	    num++;
            setTimeout('oNews['+id+'].fadeIt("'+id+'","'+text+'","'+link+'","'+font+'",'+
            size+','+speed+',"'+fn+'",'+num+',"'+c0+'","'+c1+'","'+c2+'","'+c3+'","'+
            c4+'","'+c5+'","'+c6+'")',speed);
	}
        else setTimeout('eval('+fn+')',delayfadeslide);
    }

    function nextSlide(num,id)
    {
	if(num<news[id].length)
        {
	    oNews[id].css.top=shift+"px";
            oNews[id].fadeIt( id,news[id][num]["text"],news[id][num]["link"],fontface,
                          fontsize,100,'slideNews('+num+','+id+')',13,colors[6],
                          colors[6],colors[6],colors[6],colors[6],colors[6],colors[6]);

	}
        else if(loop) nextSlide(0,id);
    }

    function slideNews(num,id)
    {
	if(oNews[id].top()>50)
        {
	    oNews[id].css.top=(oNews[id].top()-movePx)+"px";
	    setTimeout("slideNews("+num+","+id+")",30);
	}
        else if(fadeback)
        {
	    setTimeout( "oNews["+id+"].fadeIt("+id+",news["+id+"]["+num+"]['text'],"+
                "news["+id+"]["+num+"]['link'],"+
                "fontface,fontsize,100, 'nextSlide("+(num+1)+","+id+")',7,"+
                "colors[6],colors[5],colors[4],colors[3],colors[2],colors[1],colors[0])", 
                delayslidefade );
	}
        else setTimeout("nextSlide("+(num+1)+","+id+")",delayslidefade);
    }

    function start()
    {

    '''

    for url in items:
        html += '''

        oNews[divnr]=new makeObj('divNews'+divnr,'divCont'+divnr);
        nextSlide(0,divnr);

        divnr++;

        '''

    html += '''

    }

    onload=start;

    </script>
    </head>
    <body>

    <div align="center">

    '''

    width  = 175
    height = 160

    i = 0
    for url in items:
        html += '''
        
        <div id="divCont'''+i.__str__()+'''" style="background-color:#FFFFFF; position:absolute; width:'''+width.__str__()+'''px; height:'''+height.__str__()+'''px; left:10px; top:'''+(height*i+15).__str__()+'''px; clip:rect(0px,auto,150px,auto)">
        <div align="center">
        <a href="'''+url+'''">
        <img src="'''+logos[url]['link']+'''" width="'''+logos[url]['dims'][0].__str__()+'''" height="'''+logos[url]['dims'][1].__str__()+'''">
        </a>
        </div>

        <div align="center" class="sub" id="divNews'''+i.__str__()+'''" style="position:absolute; top:20px"></div></div>

        '''
        i = i + 1

    html += '''

    </div>

    </body>
    </html>

    '''

    return html



def BPLmenu_preview(url, user, group, permissions, icon, mimetype):

    html = ''

    return html


def BPLmenu_destructor():
    tmpdir = tempfile.gettempdir()
    for url in urls:
        name = re.search(r"\b\w*?.rdf\b$",url).group()
        file = tmpdir+"/"+name
        if( os.path.exists(file) ):
            os.unlink(file)


def getText(nodelist):
    rc = ""
    for node in nodelist:
        if node.nodeType == node.TEXT_NODE:
            rc = rc + node.data
    return rc

